package server;

import javax.servlet.ServletException;

import org.eclipse.jetty.server.Server;
import org.eclipse.jetty.server.handler.ContextHandler;
import org.eclipse.jetty.server.handler.ContextHandlerCollection;
import org.eclipse.jetty.server.handler.HandlerCollection;
import org.eclipse.jetty.server.handler.ResourceHandler;
import org.eclipse.jetty.servlet.ServletContextHandler;
import org.eclipse.jetty.servlet.ServletHandler;
import org.eclipse.jetty.util.resource.Resource;
import org.eclipse.jetty.websocket.servlet.WebSocketServlet;
import org.eclipse.jetty.websocket.servlet.WebSocketServletFactory;


public class EmbeddedJettyTestServer extends WebSocketServlet {
   
   /* (non-Javadoc)
    * @see org.eclipse.jetty.websocket.servlet.WebSocketServlet#init()
    */
   @Override
   public void init() throws ServletException
   {
      // TODO Auto-generated method stub
      super.init();
   }

   public static void main(String[] args) throws Exception {
      
       Server server = new Server(8080);
       
       ContextHandlerCollection handlers = new ContextHandlerCollection();
       
       ResourceHandler commonRes = new ResourceHandler();
       commonRes.setDirectoriesListed(false);

       ContextHandler contextHandler = new ContextHandler();
       contextHandler.setBaseResource(Resource.newResource("."));
       contextHandler.setWelcomeFiles(new String[] {"index.html"});
       contextHandler.setContextPath("/");
       
       contextHandler.setHandler(commonRes);
       
       handlers.addHandler(contextHandler);
       
       ServletContextHandler servletContext = new ServletContextHandler();
       servletContext.setContextPath("/");
       servletContext.addServlet(EmbeddedJettyTestServer.class, "/websocket");
       
       handlers.addHandler(servletContext);
       
       server.setHandler(handlers);

       server.start();
       server.join();
   }

   @Override
   public void configure(WebSocketServletFactory factory)
   {
      factory.getPolicy().setIdleTimeout(5000);
      factory.getPolicy().setMaxBinaryMessageSize(32 * 1024);
      factory.getPolicy().setMaxBinaryMessageBufferSize(32 * 1024 * 1024);
      factory.register(WebSocketObject.class);
   }
}
